/**
* ...
* @author Dani Llops
* @version 0.1
*/

package{
	import flash.display.*;
	import flash.events.*;
	
	public class MainLinea extends Sprite
	{	
		// MC en el escenario
		public var mensaje_mc:MovieClip;
		
		// Medidas escenario
		public static var ANCHO:int = 300;
		public static var ALTO:int = 150;
		private var _margen:int = 30;
		
		// Bitmap para poder pintar, en este caso transparente
		private var _bmpDataCanvas:BitmapData = new BitmapData(ANCHO-_margen,ALTO-_margen,true,0x11000000);
		private var _bmpCanvas:Bitmap = new Bitmap(_bmpDataCanvas);
		
		// Valores de posicion
		private var _posx:int = 10;
		private var _posy:int = 75;
		
		
		function MainLinea() 
		{		
			// Ajustamos el bitmap del canvas
			_bmpCanvas.x = _margen/2;
			_bmpCanvas.y = _margen/2;
			addChild(_bmpCanvas);
			
			// Posicionar el mensaje encima del bmp
			addChild(mensaje_mc);
			
			// Eventos
			mensaje_mc.addEventListener(MouseEvent.CLICK, init);
		}
		
		private function init(e:MouseEvent):void 
		{
			// Ajustamos posx a su valor inicial
			_posx = 10;
			
			// Pintamos el canvas del color inicial
			_bmpDataCanvas.fillRect(_bmpDataCanvas.rect, 0x11000000);
			
			// Render para dibujar
			stage.addEventListener(Event.ENTER_FRAME, dibujar);
		}
		
		private function dibujar(e:Event):void
		{
			// Pintamos un pixel utilizando un color de 32 bits, ya que el bmpData es transparente
			_bmpDataCanvas.setPixel32(_posx, _posy, 0xFFFF0000);
			
			// Aumentamos la posicion de x
			_posx++;
			
			// Parar de dibujar si la linea supera el ancho
			if (_posx > ANCHO) stage.removeEventListener(Event.ENTER_FRAME, dibujar);
		}
	}
}